Program microcalc;

Uses Crt;
Type  Real = Extended;
  
  {******** From Turbo-Pascal 3.0 'MICROCALC' (example-program) ************}
  {******************* !!!!! recursiv !!!!! ********************************}
  
Procedure Evaluate (Var Formula: String;    { Fomula to evaluate}
                   X          : Real;      { Place for x in formula }
                   Var Value: Real;        { Result of formula }
                   Var ErrPos: Integer);   { Position of error }
Const
  Numbers: Set Of Char = ['0'..'9'];
  EofLine  = ^M;
  
Var
  Pos, i: Integer;    { Current position in formula                     }
  CH: Char;           { Current character being scanned                 }
  dummy : String;
  SumR, SumL  : Integer;
  
  { Procedure NextCh returns the next character in the formula         }
  { The variable Pos contains the position ann Ch the character        }
  
Procedure NextCh;
  Begin
    Repeat
      Pos := Pos + 1;
      If Pos <= Length (Formula) Then
        CH := Formula [Pos] 
      Else CH := eofline;
    Until CH <> ' ';
  End  { NextCh } ;


  Function Fak (I: Integer): Real;  { Fakultaet }
  Var  dummy   : Real;
    j       : Integer;
  Begin
    If i = 1 Then Begin  Fak := 1;  Exit;  End;
    dummy := 1;
    For i := 1 To I Do Dummy := dummy * i;
    Fak := dummy;
  End  { Fact } ;

  Function Expression: Real;
  Var
    E: Real;
    Opr: Char;
    
  Function SimpleExpression: Real;
    Var
      S: Real;
      Opr: Char;
      
    Function Term: Real;
      Var
        T: Real;
        
      Function SignedFactor: Real;

          Function Factor: Real;
          Type
            StandardFunction = (fabs, fsqrt, fsqr, fsin, fcos,
            farctan, fln, flog, fexp, ffact, fPi, fE, fX);
            StandardFunctionList = Array [StandardFunction] Of String [6];
            
          Const
            StandardFunctionNames: StandardFunctionList = ('ABS', 'SQRT', 'SQR', 'SIN', 'COS',
            'ARCTAN', 'LN', 'LOG', 'EXP', 'FAK', 'PI', 'E', 'X');
          Var
            E, EE, L:  Integer;       { intermidiate variables }
            Found: Boolean;
            F: Real;
            Sf: StandardFunction;
            Start: Integer;
            
          Begin { Function Factor }
            If CH In Numbers Then
            Begin
              Start := Pos;
              Repeat NextCh Until Not (CH In Numbers);
              If CH = '.' Then Repeat NextCh Until Not (CH In Numbers);
              If CH = 'E' Then
              Begin
                NextCh;
                Repeat NextCh Until Not (CH In Numbers);
              End;
              Val (Copy (Formula, Start, Pos - Start), F, ErrPos);
            End Else
              If CH = '(' Then
              Begin
                NextCh;
                F := Expression;
                If CH = ')' Then NextCh Else ErrPos := Pos;
              End Else
            Begin
              found := False;
              For sf := fabs To fX Do
                If Not found Then
                Begin
                  l := Length (StandardFunctionNames [sf] );
                  If Copy (Formula, Pos, l) = StandardFunctionNames [sf] Then
                  Begin
                    Pos := Pos + l - 1; NextCh;
                    F := Factor;
                    Case sf Of
                      fabs:     f := Abs (f);
                      fsqrt:    f := Sqrt (f);
                      fsqr:     f := Sqr (f);
                      fsin:     f := Sin (f);
                      fcos:     f := Cos (f);
                      farctan:  f := ArcTan (f);
                      fln :     f := Ln (f);
                      flog:     f := Ln (f) / Ln (10);
                      fexp:     f := Exp (f);
                      ffact:    f := fak (Trunc (f) );
                      fPi:      f := Pi;
                      fE:       f := Exp (1);
                      fX:       f := X;
                    End;
                    Found := True;
                  End;
                End;
              If Not Found Then ErrPos := Pos;
            End;
            Factor := F;
          End { function Factor} ;

        Begin { SignedFactor }
          If CH = '-' Then
          Begin
            NextCh; SignedFactor := - Factor;
          End Else SignedFactor := Factor;
        End { SignedFactor } ;

      Begin { Term }
        T := SignedFactor;
        While CH = '^' Do
        Begin
          NextCh; t := Exp (Ln (t) * SignedFactor);
        End;
        Term := t;
      End { Term } ;

    Begin { SimpleExpression }
      s := term;
      While CH In ['*', '/'] Do
      Begin
        Opr := CH;  NextCh;
        Case Opr Of
          '*': s := s * term;
          '/': s := s / term;
        End;
      End;
      SimpleExpression := s;
    End { SimpleExpression } ;

  Begin { Expression }
    E := SimpleExpression;
    While CH In ['+', '-'] Do
    Begin
      Opr := CH; NextCh;
      Case Opr Of
        '+': e := e + SimpleExpression;
        '-': e := e - SimpleExpression;
      End;
    End;
    Expression := E;
  End { Expression } ;


Begin { procedure Evaluate }
  {--first make the formula a little easier --}
  
  dummy := '';     { remove all blanks }
  For i := 1 To Length (Formula) Do
    If Formula [i] <> ' ' Then Dummy := dummy + Formula [i];
  
  sumr := 0;  suml := 0;
  For i := 1 To Length (dummy) Do      { brackets ok ? }
    Case dummy [i] Of
      ',' : dummy [i] := '.';
      '(' : Inc (SumR);
      ')' : Inc (SumL);
      Else dummy [i] := UpCase (dummy [i] );
    End;
  
  i := 1;
  Repeat
    Inc (i);
    If (dummy [i] = '.') And Not (dummy [i - 1] In numbers) Then
    Begin
      Insert ('0', dummy, i);  Inc (i);
    End;
  Until i >= Length (dummy);
  
  If dummy [1] = '.' Then Insert ('0', dummy, 1);
  If dummy [1] = '+' Then Delete (dummy, 1, 1);
  
  If dummy = '' Then
  Begin Value := 0;  ErrPos := - 1;  Exit;  End;
  If sumR <> sumL Then
  Begin Value := 0;  ErrPos := - 2;  Exit;  End;
  
  Formula := Dummy;
  Pos := 0; NextCh;
  Value := Expression;
  If CH = EofLine Then ErrPos := 0 Else ErrPos := Pos;
End { Evaluate } ;


Var
  Value, X  : Real;
  ErrPos, i : Integer;
  Formula    : String;
  
Begin      { Main (Example) }
  ClrScr;
  Formula := '1+0.10';
  Evaluate (Formula, 0, Value, ErrPos);
  WriteLn ('error', ErrPos);
  WriteLn (Formula, ' =  ', Value: 7: 10, '  Possibilitys in "German Lotto"');
  
  Formula := '100000^(1/5)*cos(pi)';
  Evaluate (Formula, 0, Value, ErrPos);
  WriteLn (Formula, ' =  ', Value: 7: 2, '');
  
  WriteLn;
  Formula := 'exp(cos(-2*Sqr(x) - 4*x+ 3))/(1/(x+0.01))';
  For i := 0 To 10 Do
  Begin
    X := i * 0.1;
    Evaluate (Formula, X, Value, ErrPos);
    WriteLn ('x = ', X: 5: 1, '  ', Formula, ' =  ', Value: 7: 3);
  End;
  
End.
